#include "CBm32.h"

#define MULT1	255		// |ZΉ\̔搔̍ől
#define MULT2	255		// |ZΉ\̏搔̍őligMultTbl1j
#define MULT3	64		// |ZΉ\̏搔̍őligMultTbl2j
#define DIV1	255 * 3 // ZΉ\̔폜̍ől

BYTE	gMultTbl1[MULT1+1][MULT2+1];	// |ZΉ\1
BYTE	gMultTbl2[MULT1+1][MULT3+1];	// |ZΉ\2
WORD	gDivTbl[DIV1+1];				// ZΉ\
LOGFONT glFont;

void	b32Init();

extern "C" int APIENTRY DllMain( HINSTANCE hInst, DWORD dwReason, LPVOID lpRsv )
{
	switch(dwReason)
	{
	case DLL_PROCESS_ATTACH:
		b32Init();
		break;
	}
	return TRUE;
}

// 
void b32Init()
{
	// tHg
	ZeroMemory(&glFont, sizeof(glFont));
	_tcsncpy(glFont.lfFaceName, TEXT("lr SVbN"), sizeof(glFont.lfFaceName));
	glFont.lfWeight 		= 700;
	glFont.lfCharSet		= SHIFTJIS_CHARSET;
	glFont.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;
	glFont.lfQuality		= ANTIALIASED_QUALITY;
	// |ZΉ\쐬
	int i, j;
	for(i=0; i<=MULT1; i++){
		for(j=0; j<=MULT2; j++){
			gMultTbl1[i][j]  = (i * j) / MULT2;
		}
	}
	for(i=0; i<=MULT1; i++){
		for(j=0; j<=MULT3; j++){
			gMultTbl2[i][j]  = (i * j) / MULT3;
		}
	}
	// ZΉ\쐬
	for(i=0; i<=DIV1; i++){
		gDivTbl[i]  = i / 3;
	}
}// b32Init

// CBm32 ̃RXgN^
CBm32::CBm32()
{
	m_hBmp = NULL;
}// CBm32

// 32bppDIB ̐VK쐬
// width	: [IN]	摜̕
// height	: [IN]	摜̍
void CBm32::Create(int width, int height)
{
	m_hBmp = CreateSub(width, height);
}// Create

// 摜 32bppDIB ɓǂݍ
// filename : [IN]	rbg}bv t@C
// x, y 	: [IN]	ǂݍ݋`̍W
// width	: [IN]	ǂݍ݋`̕i0 ̏ꍇ͉摜̕j
// height	: [IN]	ǂݍ݋`̍i0 ̏ꍇ͉摜̍j
BOOL CBm32::Create(TCHAR *filename, int x, int y, int width, int height)
{
	BITMAP	bmp;
	HBITMAP hBmpIn;
	
	hBmpIn = (HBITMAP) LoadImage(NULL, filename, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | LR_CREATEDIBSECTION);
	if(hBmpIn == NULL) return FALSE;
	
	GetObject(hBmpIn, sizeof(bmp), &bmp);
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	
	m_hBmp = CreateSub(width, height);
	
	HDC 	hdcCp1,hdcCp2;
	HBITMAP hbmOld1,hbmOld2;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	if(hdcCp1 && hdcCp2){
		hbmOld1 = (HBITMAP)SelectObject(hdcCp1, m_hBmp);
		hbmOld2 = (HBITMAP)SelectObject(hdcCp2, hBmpIn);
		BitBlt(hdcCp1, 0, 0, width, height, hdcCp2, x, y, SRCCOPY);
		SelectObject(hdcCp1, hbmOld1);
		SelectObject(hdcCp2, hbmOld2);
	}
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	DeleteObject(hBmpIn);
	
	if(bmp.bmBitsPixel < 32){
		ChangeAlpha(255);
	}
	
	_tcsncpy(m_strFilename, filename, MAX_PATH);

	return TRUE;
}// Create

// rbg}bvnh̉
// ߂l	:		1:A0:s
BOOL CBm32::Delete()
{
	BOOL res = FALSE;
	
	if(m_hBmp){
		if(DeleteObject(m_hBmp)){
			m_hBmp = NULL;
			res = TRUE;
		}
	}
	return res;
}// Delete

// 摜̍ēǂݍ
// filename : [IN]	rbg}bv t@C
// x, y 	: [IN]	ǂݍ݋`̍W
// width	: [IN]	ǂݍ݋`̕i0 ̏ꍇ͉摜̕j
// height	: [IN]	ǂݍ݋`̍i0 ̏ꍇ͉摜̍j
// ߂l	:		1:A0:s
BOOL CBm32::Reload(TCHAR *filename, int x, int y, int width, int height)
{
	BOOL	res = FALSE;
	BITMAP	bmp;
	HBITMAP hBmpIn;
	
	hBmpIn = (HBITMAP) LoadImage(NULL, filename, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | LR_CREATEDIBSECTION);
	if(hBmpIn == NULL) return FALSE;
	
	GetObject(hBmpIn, sizeof(bmp), &bmp);
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	
	HDC 	hdcCp1,hdcCp2;
	HBITMAP hbmOld1,hbmOld2;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	if(hdcCp1 && hdcCp2){
		hbmOld1 = (HBITMAP)SelectObject(hdcCp1, m_hBmp);
		hbmOld2 = (HBITMAP)SelectObject(hdcCp2, hBmpIn);
		BitBlt(hdcCp1, 0, 0, width, height, hdcCp2, x, y, SRCCOPY);
		SelectObject(hdcCp1, hbmOld1);
		SelectObject(hdcCp2, hbmOld2);
		res = TRUE;
	}
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	DeleteObject(hBmpIn);
	
	if(bmp.bmBitsPixel < 32){
		ChangeAlpha(255);
	}
	
	return res;
}// Reload

// DIB ̕`iHBITMAPj
// bm32			: [IN][OUT] Rs[rbg}bv
// xDst, yDst	: [IN]		Rs[W
// xSrc, ySrc	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// ߂l		:			1:A0:s
BOOL CBm32::Draw(CBm32 &bm32, int xDst, int yDst, int xSrc, int ySrc,
			int width, int height)
{
	HBITMAP hBmpDst = bm32.GetHBmp();
	if(!hBmpDst || !m_hBmp) return FALSE;
	
	BOOL	res = FALSE;
	HDC 	hdcCp1,hdcCp2;
	HBITMAP hbmOld1,hbmOld2;
	BITMAP	bmp;
	
	GetObject(m_hBmp, sizeof(bmp), &bmp);
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	if(hdcCp1 && hdcCp2){
		hbmOld1 = (HBITMAP)SelectObject(hdcCp1, hBmpDst);
		hbmOld2 = (HBITMAP)SelectObject(hdcCp2, m_hBmp);
		BitBlt(hdcCp1, xDst, yDst, width, height, hdcCp2, xSrc, ySrc, SRCCOPY);
		SelectObject(hdcCp1, hbmOld1);
		SelectObject(hdcCp2, hbmOld2);
		res = TRUE;
	}
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	
	return res;
}// Draw

// DIB ̕`ifoCXReLXgj
// hDC			: [IN][OUT] Rs[foCXReLXg
// xDst, yDst	: [IN]		Rs[W
// xSrc, ySrc	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// ߂l		:			1:A0:s
BOOL CBm32::DrawDC(HDC hDC, int xDst, int yDst, int xSrc, int ySrc,
			   int width, int height)
{
	if(!hDC || !m_hBmp) return FALSE;
	
	BOOL	res = FALSE;
	HDC 	hdcCp;
	HBITMAP hbmpPre;
	BITMAP	bmp;
	
	GetObject(m_hBmp, sizeof(bmp), &bmp);
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	
	hdcCp = CreateCompatibleDC(hDC);
	if(hdcCp){
		hbmpPre = (HBITMAP) SelectObject(hdcCp, m_hBmp);
		BitBlt(hDC, xDst, yDst, width, height, hdcCp, xSrc, ySrc, SRCCOPY);
		SelectObject(hdcCp, hbmpPre);
		DeleteDC(hdcCp);
		res = TRUE;
	}
	
	return res;
}// DrawDC

// DIB ̕`igEkj
// bm32					: [IN][OUT] Rs[rbg}bvnh
// xDst, yDst			: [IN]		Rs[W
// widthDst, heightDst	: [IN]		Rs[`̕ƍ
// xSrc, ySrc			: [IN]		Rs[W
// widthSrc, heightSrc	: [IN]		Rs[`̕ƍ
// ߂l				:			1:A0:s
BOOL CBm32::DrawEx(CBm32 &bm32, int xDst, int yDst, int widthDst, int heightDst,
			   int xSrc, int ySrc, int widthSrc, int heightSrc)
{
	HBITMAP hBmpDst = bm32.GetHBmp();
	if(!hBmpDst || !m_hBmp) return FALSE;
	
	BOOL	res = FALSE;
	HDC 	hdcCp1,hdcCp2;
	HBITMAP hbmOld1,hbmOld2;
	BITMAP	bmp;
	
	GetObject(m_hBmp, sizeof(bmp), &bmp);
	if(widthSrc <= 0)	widthSrc  = bmp.bmWidth;
	if(heightSrc <= 0)	heightSrc = bmp.bmHeight;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	if(hdcCp1 && hdcCp2){
		hbmOld1 = (HBITMAP)SelectObject(hdcCp1, hBmpDst);
		hbmOld2 = (HBITMAP)SelectObject(hdcCp2, m_hBmp);
		StretchBlt(hdcCp1, xDst, yDst, widthDst, heightDst, hdcCp2, xSrc, ySrc, widthSrc, heightSrc, SRCCOPY);
		SelectObject(hdcCp1, hbmOld1);
		SelectObject(hdcCp2, hbmOld2);
		res = TRUE;
	}
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	
	return res;
}// DrawEx

// DIB ̔F`iHBITMAPj
// bm32			: [IN][OUT] Rs[rbg}bvnh
// xDst, yDst	: [IN]		Rs[W
// xSrc, ySrc	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// ߂l		:			1:A0:s
BOOL CBm32::DrawKey(CBm32 &bm32, int xDst, int yDst, int xSrc, int ySrc, int width, int height)
{
	HBITMAP hBmpDst = bm32.GetHBmp();
	if(!hBmpDst || !m_hBmp) return FALSE;
	
	BOOL	res = FALSE;
	HDC 	hdcCp1,hdcCp2;
	HBITMAP hbmOld1,hbmOld2;
	BITMAP	bmp;
	
	GetObject(m_hBmp, sizeof(bmp), &bmp);
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	if(hdcCp1 && hdcCp2){
		hbmOld1 = (HBITMAP)SelectObject(hdcCp1, hBmpDst);
		hbmOld2 = (HBITMAP)SelectObject(hdcCp2, m_hBmp);
		TransparentBlt(hdcCp1, xDst, yDst, width, height, hdcCp2, xSrc, ySrc, width, height, m_nColorkey);
		SelectObject(hdcCp1, hbmOld1);
		SelectObject(hdcCp2, hbmOld2);
		res = TRUE;
	}
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	
	return res;
}// DrawKey

// DIB ̔F`ifoCXReLXgj
// hDC			: [IN][OUT] Rs[foCXReLXg
// xDst, yDst	: [IN]		Rs[W
// xSrc, ySrc	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// ߂l		:			1:A0:s
BOOL CBm32::DrawKeyDC(HDC hDC, int xDst, int yDst, int xSrc, int ySrc, int width, int height)
{
	if(!hDC || !m_hBmp) return FALSE;
	
	BOOL	res = FALSE;
	HDC 	hdcCp;
	HBITMAP hbmpPre;
	BITMAP	bmp;
	
	GetObject(m_hBmp, sizeof(bmp), &bmp);
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	
	hdcCp = CreateCompatibleDC(hDC);
	if(hdcCp){
		hbmpPre = (HBITMAP) SelectObject(hdcCp, m_hBmp);
		TransparentBlt(hDC, xDst, yDst, width, height, hdcCp, xSrc, ySrc, width, height, m_nColorkey);
		SelectObject(hdcCp, hbmpPre);
		DeleteDC(hdcCp);
		res = TRUE;
	}
	
	return res;
}// DrawKeyDC

// DIB ̔F`igEkj
// bm32					: [IN][OUT] Rs[rbg}bvnh
// xDst, yDst			: [IN]		Rs[W
// widthDst, heightDst	: [IN]		Rs[`̕ƍ
// xSrc, ySrc			: [IN]		Rs[W
// widthSrc, heightSrc	: [IN]		Rs[`̕ƍ
// ߂l				:			1:A0:s
BOOL CBm32::DrawKeyEx(CBm32 &bm32, int xDst, int yDst, int widthDst, int heightDst,
				  int xSrc, int ySrc, int widthSrc, int heightSrc)
{
	HBITMAP hBmpDst = bm32.GetHBmp();
	if(!hBmpDst || !m_hBmp) return FALSE;
	
	BOOL	res = FALSE;
	HDC 	hdcCp1,hdcCp2;
	HBITMAP hbmOld1,hbmOld2;
	BITMAP	bmpSrc,bmpDst;
	
	GetObject(m_hBmp, sizeof(bmpSrc), &bmpSrc);
	if(widthSrc <= 0)	widthSrc  = bmpSrc.bmWidth;
	if(heightSrc <= 0)	heightSrc = bmpSrc.bmHeight;
	GetObject(hBmpDst, sizeof(bmpDst), &bmpDst);
	if(widthDst <= 0)	widthDst  = bmpDst.bmWidth;
	if(heightDst <= 0)	heightDst = bmpDst.bmHeight;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	if(hdcCp1 && hdcCp2){
		hbmOld1 = (HBITMAP)SelectObject(hdcCp1, hBmpDst);
		hbmOld2 = (HBITMAP)SelectObject(hdcCp2, m_hBmp);
		TransparentBlt(hdcCp1, xDst, yDst, widthDst, heightDst, hdcCp2, xSrc, ySrc, widthSrc, heightSrc, m_nColorkey);
		SelectObject(hdcCp1, hbmOld1);
		SelectObject(hdcCp2, hbmOld2);
		res = TRUE;
	}
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	
	return res;
}// DrawKeyEx

// DIB ̔`iHBITMAPj
// bm32			: [IN][OUT] Rs[rbg}bvnh
// xDst, yDst	: [IN]		Rs[W
// xSrc, ySrc	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// alpha		: [IN]		Ŝ̓xi0 - 255j
// ߂l		:			1:A0:s
BOOL CBm32::DrawAlpha(CBm32 &bm32, int xDst, int yDst, int xSrc, int ySrc,
				  int width, int height, BYTE alpha)
{
	HBITMAP hBmpDst = bm32.GetHBmp();
	if(!hBmpDst || !m_hBmp) return FALSE;
	
	if(alpha < 0)	alpha = 0;
	if(alpha > 255)	alpha = 255;
	if(alpha == 0)	return FALSE;
	
	BOOL			res = FALSE;
	HDC 			hdcCp1,hdcCp2;
	HBITMAP 		hbmOld1,hbmOld2;
	BITMAP			bmp;
	BLENDFUNCTION	bf;
	
	bf.BlendOp				= AC_SRC_OVER;
	bf.BlendFlags			= 0;
	bf.SourceConstantAlpha	= alpha;
	bf.AlphaFormat			= 0;
	
	GetObject(m_hBmp, sizeof(bmp), &bmp);
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	if(hdcCp1 && hdcCp2){
		hbmOld1 = (HBITMAP)SelectObject(hdcCp1, hBmpDst);
		hbmOld2 = (HBITMAP)SelectObject(hdcCp2, m_hBmp);
		AlphaBlend(hdcCp1, xDst, yDst, width, height, hdcCp2, xSrc, ySrc, width, height, bf);
		SelectObject(hdcCp1, hbmOld1);
		SelectObject(hdcCp2, hbmOld2);
		res = TRUE;
	}
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	
	return res;
}// DrawAlpha

// DIB ̔`ifoCXReLXgj
// hDC			: [IN][OUT] Rs[foCXReLXg
// xDst, yDst	: [IN]		Rs[W
// xSrc, ySrc	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// alpha		: [IN]		Ŝ̓xi0 - 255j
// ߂l		:			1:A0:s
BOOL CBm32::DrawAlphaDC(HDC hDC, int xDst, int yDst, int xSrc, int ySrc,
					int width, int height, BYTE alpha)
{
	if(!hDC || !m_hBmp) return FALSE;
	
	if(alpha < 0)	alpha = 0;
	if(alpha > 255)	alpha = 255;
	if(alpha == 0)	return FALSE;
	
	BOOL			res = FALSE;
	HDC 			hdcCp;
	HBITMAP 		hbmpPre;
	BITMAP			bmp;
	BLENDFUNCTION	bf;
	
	bf.BlendOp				= AC_SRC_OVER;
	bf.BlendFlags			= 0;
	bf.SourceConstantAlpha	= alpha;
	bf.AlphaFormat			= 0;
	
	GetObject(m_hBmp, sizeof(bmp), &bmp);
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	
	hdcCp = CreateCompatibleDC(hDC);
	if(hdcCp){
		hbmpPre = (HBITMAP) SelectObject(hdcCp, m_hBmp);
		AlphaBlend(hDC, xDst, yDst, width, height, hdcCp, xSrc, ySrc, width, height, bf);
		SelectObject(hdcCp, hbmpPre);
		DeleteDC(hdcCp);
		res = TRUE;
	}
	
	return res;
}// DrawAlphaDC

// DIB ̔`igEkj
// bm3					: [IN][OUT] Rs[rbg}bvnh
// xDst, yDst			: [IN]		Rs[W
// widthDst, heightDst	: [IN]		Rs[`̕ƍ
// xSrc, ySrc			: [IN]		Rs[W
// widthSrc, heightSrc	: [IN]		Rs[`̕ƍ
// alpha				: [IN]		Ŝ̓xi0 - 255j
// ߂l				:			1:A0:s
BOOL CBm32::DrawAlphaEx(CBm32 &bm32, int xDst, int yDst, int widthDst, int heightDst,
					int xSrc, int ySrc, int widthSrc, int heightSrc, BYTE alpha)
{
	HBITMAP hBmpDst = bm32.GetHBmp();
	if(!hBmpDst || !m_hBmp) return FALSE;
	
	if(alpha < 0)	alpha = 0;
	if(alpha > 255)	alpha = 255;
	if(alpha == 0)	return FALSE;
	
	BOOL			res = FALSE;
	HDC 			hdcCp1,hdcCp2;
	HBITMAP 		hbmOld1,hbmOld2;
	BITMAP			bmpSrc,bmpDst;
	BLENDFUNCTION	bf;
	
	bf.BlendOp				= AC_SRC_OVER;
	bf.BlendFlags			= 0;
	bf.SourceConstantAlpha	= alpha;
	bf.AlphaFormat			= 0;
	
	GetObject(m_hBmp, sizeof(bmpSrc), &bmpSrc);
	if(widthSrc <= 0)	widthSrc  = bmpSrc.bmWidth;
	if(heightSrc <= 0)	heightSrc = bmpSrc.bmHeight;
	GetObject(hBmpDst, sizeof(bmpDst), &bmpDst);
	if(widthDst <= 0)	widthDst  = bmpDst.bmWidth;
	if(heightDst <= 0)	heightDst = bmpDst.bmHeight;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	if(hdcCp1 && hdcCp2){
		hbmOld1 = (HBITMAP)SelectObject(hdcCp1, hBmpDst);
		hbmOld2 = (HBITMAP)SelectObject(hdcCp2, m_hBmp);
		AlphaBlend(hdcCp1, xDst, yDst, widthDst, heightDst, hdcCp2, xSrc, ySrc, widthSrc, heightSrc, bf);
		SelectObject(hdcCp1, hbmOld1);
		SelectObject(hdcCp2, hbmOld2);
		res = TRUE;
	}
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	
	return res;
}// DrawAlphaEx

// 32bppDIB ̓x`
// bm32			: [IN][OUT] Rs[rbg}bvnh
// xDst, yDst	: [IN]		Rs[W
// xSrc, ySrc	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// alpha		: [IN]		Ŝ̓xi0 - 255j
// ߂l		:			1:A0:s
BOOL CBm32::Draw32(CBm32 &bm32, int xDst, int yDst,
			   int xSrc, int ySrc, int width, int height, BYTE alpha)
{
	HBITMAP hBmpDst = bm32.GetHBmp();
	PBYTE	pbSrc	= GetBits();
	PBYTE	pbDst	= bm32.GetBits();
	if(!hBmpDst || !m_hBmp || !pbSrc || !pbDst) return FALSE;
	
	if(alpha < 0)	alpha = 0;
	if(alpha > 255)	alpha = 255;
	if(alpha == 0)	return FALSE;
	
	BITMAP	bmpSrc,bmpDst;
	GetObject(m_hBmp, sizeof(bmpSrc), &bmpSrc);
	GetObject(hBmpDst, sizeof(bmpDst), &bmpDst);
	if(bmpSrc.bmBitsPixel != 32)	return FALSE;
	if(bmpDst.bmBitsPixel != 32)	return FALSE;
	if(width <= 0)	width  = bmpSrc.bmWidth;
	if(height <= 0) height = bmpSrc.bmHeight;
	
	int wdhSrc = bmpSrc.bmWidth;
	int hgtSrc = bmpSrc.bmHeight;
	int wdhDst = bmpDst.bmWidth;
	int hgtDst = bmpDst.bmHeight;
	
	RECT rc = Clip32(xSrc, ySrc, width, height, wdhSrc, hgtSrc);
	
	int 	i, j, sum_r, sum_g, sum_b, dst_x, dst_y;
	DWORD	ba;
	BYTE	br, bg, bb, sa, sa2, sr, sg, sb;
	
	PDWORD	ps = (PDWORD) pbSrc + rc.top * wdhSrc;
	PDWORD	pb = (PDWORD) pbDst + yDst * wdhDst;
	int		width_rest_src = wdhSrc - rc.right;
	int		width_rest_dst = wdhDst - (rc.right + (xDst - rc.left));
	for(i = rc.top; i < rc.bottom; i++){
		ps += rc.left;
		pb += xDst;
		dst_y = i + yDst - rc.top;
		for(j = rc.left; j < rc.right; j++){
			dst_x = j + xDst - rc.left;
			if(dst_x >= 0 && dst_y >= 0 && dst_x >= xDst && dst_y >= yDst && dst_x < wdhDst && dst_y < hgtDst){
				ba = *pb & 0xff000000;
				br = (BYTE)(*pb >> 16);
				bg = (BYTE)(*pb >> 8);
				bb = (BYTE) *pb;
				sa = (BYTE)(*ps >> 24);
				sr = (BYTE)(*ps >> 16);
				sg = (BYTE)(*ps >> 8);
				sb = (BYTE) *ps;
				if(alpha < 255){
					sa  = gMultTbl1[sa][alpha];
				}
				sa2 = 255 - sa;
				sum_r = gMultTbl1[br][sa2] + gMultTbl1[sr][sa];
				sum_g = gMultTbl1[bg][sa2] + gMultTbl1[sg][sa];
				sum_b = gMultTbl1[bb][sa2] + gMultTbl1[sb][sa];
				if(sum_r > 255) sum_r = 255;
				if(sum_g > 255) sum_g = 255;
				if(sum_b > 255) sum_b = 255;
				*pb = ba | (sum_r << 16) | (sum_g << 8) | sum_b;
			}
			ps ++;
			pb ++;
		}
		ps += width_rest_src;
		pb += width_rest_dst;
	}
	
	return TRUE;
}// Draw32

// 32bppDIB ̉Z`
// bm32			: [IN][OUT] Rs[rbg}bvnh
// xDst, yDst	: [IN]		Rs[W
// xSrc, ySrc	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// alpha		: [IN]		Ŝ̓xi0 - 255j
// bMinus		: [IN]		ZtOi0:ZA1:Zj
// ߂l		:			1:A0:s
BOOL CBm32::DrawAddAlpha(CBm32 &bm32, int xDst, int yDst, int xSrc, int ySrc,
					 int width, int height, BYTE alpha, BOOL bMinus)
{
	HBITMAP	hBmpDst = bm32.GetHBmp();
	PBYTE	pbSrc	= GetBits();
	PBYTE	pbDst	= bm32.GetBits();
	if(!hBmpDst || !m_hBmp || !pbSrc || !pbDst) return FALSE;
	
	if(alpha < 0)	alpha = 0;
	if(alpha > 255)	alpha = 255;
	if(alpha == 0)	return FALSE;
	
	BITMAP	bmpSrc,bmpDst;
	GetObject(m_hBmp, sizeof(bmpSrc), &bmpSrc);
	GetObject(hBmpDst, sizeof(bmpDst), &bmpDst);
	if(bmpSrc.bmBitsPixel != 32)	return FALSE;
	if(bmpDst.bmBitsPixel != 32)	return FALSE;
	if(width <= 0)	width  = bmpSrc.bmWidth;
	if(height <= 0) height = bmpSrc.bmHeight;
	
	int wdhSrc = bmpSrc.bmWidth;
	int hgtSrc = bmpSrc.bmHeight;
	int wdhDst = bmpDst.bmWidth;
	int hgtDst = bmpDst.bmHeight;
	
	RECT rc = Clip32(xSrc, ySrc, width, height, wdhSrc, hgtSrc);
	
	int 	i, j, sum_r, sum_g, sum_b, dst_x, dst_y;
	DWORD	ba;
	BYTE	br, bg, bb, sr, sg, sb;
	
	PDWORD	ps = (PDWORD) pbSrc + rc.top * wdhSrc;
	PDWORD	pb = (PDWORD) pbDst + yDst * wdhDst;
	int		width_rest_src = wdhSrc - rc.right;
	int		width_rest_dst = wdhDst - (rc.right + (xDst - rc.left));
	for(i = rc.top; i < rc.bottom; i++){
		ps += rc.left;
		pb += xDst;
		dst_y = i + yDst - rc.top;
		for(j = rc.left; j < rc.right; j++){
			dst_x = j + xDst - rc.left;
			if(dst_x >= 0 && dst_y >= 0 && dst_x >= xDst && dst_y >= yDst && dst_x < wdhDst && dst_y < hgtDst){
				ba = *pb & 0xff000000;
				br = (BYTE)(*pb >> 16);
				bg = (BYTE)(*pb >> 8);
				bb = (BYTE) *pb;
				sr = (BYTE)(*ps >> 16);
				sg = (BYTE)(*ps >> 8);
				sb = (BYTE) *ps;
				if(!bMinus){
					sum_r = br + gMultTbl1[sr][alpha];	// br + sr * alpha / 255 ̂
					sum_g = bg + gMultTbl1[sg][alpha];
					sum_b = bb + gMultTbl1[sb][alpha];
					if(sum_r > 255) sum_r = 255;
					if(sum_g > 255) sum_g = 255;
					if(sum_b > 255) sum_b = 255;
				}
				else{
					sum_r = br - gMultTbl1[sr][alpha];
					sum_g = bg - gMultTbl1[sg][alpha];
					sum_b = bb - gMultTbl1[sb][alpha];
					if(sum_r < 0) sum_r = 0;
					if(sum_g < 0) sum_g = 0;
					if(sum_b < 0) sum_b = 0;
				}
				*pb = ba | (sum_r << 16) | (sum_g << 8) | sum_b;
			}
			ps ++;
			pb ++;
		}
		ps += width_rest_src;
		pb += width_rest_dst;
	}
	
	return TRUE;
}// DrawAddAlpha

// 32bppDIB ̒PFhԂ
// alpha		: [IN]		x
// red			: [IN]		ԐF
// green		: [IN]		ΐF
// blue 		: [IN]		F
// x, y 		: [IN]		`̍W
// width, height: [IN]		`̕ƍ
// ߂l		:			1:A0:s
BOOL CBm32::DrawColor(BYTE alpha, BYTE red, BYTE green, BYTE blue,
				  int x, int y, int width, int height)
{
	PBYTE	pbSrc	= GetBits();
	if(!m_hBmp || !pbSrc) return FALSE;
	
	// rbg}bv擾Ɖ摜̕ƍ̐ݒ
	BITMAP	bmp;
	GetObject(m_hBmp, sizeof(bmp), &bmp);
	if(bmp.bmBitsPixel != 32)	return FALSE;
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	// eF 0 ` 255 ͈̔͂ɐݒ
	if(alpha < 0)	alpha = 0;
	if(alpha > 255)	alpha = 255;
	if(red < 0)		red = 0;
	if(red > 255)	red = 255;
	if(green < 0)	green = 0;
	if(green > 255)	green = 255;
	if(blue < 0)	blue = 0;
	if(blue > 255)	blue = 255;
	// NbsO
	RECT rc = Clip32(x, y, width, height, bmp.bmWidth, bmp.bmHeight);
	// h荞
	int 	i, j;
	DWORD	color = (alpha << 24) | (red << 16) | (green << 8) | blue;
	PDWORD	pb = (PDWORD) pbSrc + rc.top * bmp.bmWidth;
	int		width_rest = bmp.bmWidth - rc.right;
	for(i = rc.top; i < rc.bottom; i++){
		pb += rc.left;
		for(j = rc.left; j < rc.right; j++){
			
			*pb = color;
			pb ++;
		}
		pb += width_rest;
	}
	
	return TRUE;
}// DrawColor

// 32bppDIB ̒PFZhԂ
// red			: [IN]		ԐF
// green		: [IN]		ΐF
// blue 		: [IN]		F
// x, y 		: [IN]		`̍W
// width, height: [IN]		`̕ƍ
// bMinus		: [IN]		ZtOi0:ZA1:Zj
// ߂l		:			1:A0:s
BOOL CBm32::AddColor(BYTE red, BYTE green, BYTE blue,
				  int x, int y, int width, int height, BOOL bMinus)
{
	PBYTE	pbSrc	= GetBits();
	if(!m_hBmp || !pbSrc) return FALSE;
	
	// rbg}bv擾Ɖ摜̕ƍ̐ݒ
	BITMAP	bmp;
	GetObject(m_hBmp, sizeof(bmp), &bmp);
	if(bmp.bmBitsPixel != 32)	return FALSE;
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	// eF 0 ` 255 ͈̔͂ɐݒ
	if(red < 0)		red = 0;
	if(red > 255)	red = 255;
	if(green < 0)	green = 0;
	if(green > 255)	green = 255;
	if(blue < 0)	blue = 0;
	if(blue > 255)	blue = 255;
	// NbsO
	RECT rc = Clip32(x, y, width, height, bmp.bmWidth, bmp.bmHeight);
	// h荞
	int 	i, j, na, nr, ng, nb;
	PDWORD	pb = (PDWORD) pbSrc + rc.top * bmp.bmWidth;
	int		width_rest = bmp.bmWidth - rc.right;
	for(i = rc.top; i < rc.bottom; i++){
		pb += rc.left;
		for(j = rc.left; j < rc.right; j++){
			na = *pb & 0xff000000;
			if(!bMinus){
				nr = (BYTE)(*pb >> 16) + red;
				ng = (BYTE)(*pb >> 8)  + green;
				nb = (BYTE) *pb        + blue;
				if(nr > 255)	nr = 255;
				if(ng > 255)	ng = 255;
				if(nb > 255)	nb = 255;
			}
			else{
				nr = (BYTE)(*pb >> 16) - red;
				ng = (BYTE)(*pb >> 8)  - green;
				nb = (BYTE) *pb        - blue;
				if(nr < 0)	nr = 0;
				if(ng < 0)	ng = 0;
				if(nb < 0)	nb = 0;
			}
			*pb = na | (nr << 16) | (ng << 8) | nb;
			pb ++;
		}
		pb += width_rest;
	}
	
	return TRUE;
}// AddColor

// 32bppDIB ̓xꗥύX
// alpha		: [IN]		x
// x, y 		: [IN]		`̍W
// width, height: [IN]		`̕ƍ
// ߂l		:			1:A0:s
BOOL CBm32::ChangeAlpha(BYTE alpha, int x, int y, int width, int height)
{
	PBYTE	pbSrc	= GetBits();
	if(!m_hBmp || !pbSrc) return FALSE;
	
	// rbg}bv擾Ɖ摜̕ƍ̐ݒ
	BITMAP	bmp;
	GetObject(m_hBmp, sizeof(bmp), &bmp);
	if(bmp.bmBitsPixel != 32)	return FALSE;
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	// eF 0 ` 255 ͈̔͂ɐݒ
	if(alpha < 0)	alpha = 0;
	if(alpha > 255)	alpha = 255;
	// NbsO
	RECT rc = Clip32(x, y, width, height, bmp.bmWidth, bmp.bmHeight);
	// h荞
	int 	i, j;
	DWORD	alpha2 = alpha << 24;
	PDWORD	pb = (PDWORD) pbSrc + rc.top * bmp.bmWidth;
	int		width_rest = bmp.bmWidth - rc.right;
	for(i = rc.top; i < rc.bottom; i++){
		pb += rc.left;
		for(j = rc.left; j < rc.right; j++){
			*pb &= 0x00FFFFFF;
			*pb |= alpha2;
			pb ++;
		}
		pb += width_rest;
	}
	
	return TRUE;
}// ChangeAlpha

// 32bppDIB ̃mN
// x, y 		: [IN]		`̍W
// width, height: [IN]		`̕ƍ
// ߂l		:			1:A0:s
BOOL CBm32::Monotone(int x, int y, int width, int height)
{
	PBYTE	pbSrc	= GetBits();
	if(!m_hBmp || !pbSrc) return FALSE;
	
	// rbg}bv擾Ɖ摜̕ƍ̐ݒ
	BITMAP	bmp;
	GetObject(m_hBmp, sizeof(bmp), &bmp);
	if(bmp.bmBitsPixel != 32)	return FALSE;
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	// NbsO
	RECT rc = Clip32(x, y, width, height, bmp.bmWidth, bmp.bmHeight);
	// h荞
	DWORD	a;
	BYTE	r, g, b;
	int 	i, j, color;
	PDWORD	pb = (PDWORD) pbSrc + rc.top * bmp.bmWidth;
	int		width_rest = bmp.bmWidth - rc.right;
	for(i = rc.top; i < rc.bottom; i++){
		pb += rc.left;
		for(j = rc.left; j < rc.right; j++){
			a = *pb & 0xff000000;
			r = (BYTE)(*pb >> 16);
			g = (BYTE)(*pb >> 8);
			b = (BYTE) *pb;
			color = gDivTbl[r + g + b];
//			if(color > 255)	color = 255;
			r = g = b = color;
			*pb = a | (r << 16) | (g << 8) | b;
			pb ++;
		}
		pb += width_rest;
	}
	
	return TRUE;
}// Monotone

// 32bppDIB ̐FϊiHBITMAPj
// hue			: [IN]		F[g 0 - 192i32F, 96F, 144Fj
// x, y 		: [IN]		`̍W
// width, height: [IN]		`̕ƍ
// ߂l		:			1:A0:s
BOOL CBm32::Hue(int hue, int x, int y, int width, int height)
{
	PBYTE	pbSrc	= GetBits();
	if(!m_hBmp || !pbSrc) return FALSE;
	
	// rbg}bv擾Ɖ摜̕ƍ̐ݒ
	BITMAP	bmp;
	GetObject(m_hBmp, sizeof(bmp), &bmp);
	if(bmp.bmBitsPixel != 32)	return FALSE;
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	// F[gݒ
	if (hue > 192)		hue = 192;
	else if (hue <	0)	hue = 0;
	int hue2 = 64 - hue;
	int hue3 = hue - 64;
	int hue4 = 128 - hue;
	int hue5 = hue - 128;
	int hue6 = 192 - hue;
	// NbsO
	RECT rc = Clip32(x, y, width, height, bmp.bmWidth, bmp.bmHeight);
	// Fϊ
	DWORD	a;
	BYTE	r, g, b;
	BYTE	fr1, fr2, fg1, fg2, fb1, fb2;
	int 	i, j;
	PDWORD	pb = (PDWORD) pbSrc + rc.top * bmp.bmWidth;
	int		width_rest = bmp.bmWidth - rc.right;
	for(i = rc.top; i < rc.bottom; i++){
		pb += rc.left;
		for(j = rc.left; j < rc.right; j++){
			a = *pb & 0xff000000;
			r = (BYTE)(*pb >> 16);
			g = (BYTE)(*pb >> 8);
			b = (BYTE) *pb;
			if(hue >= 0 && hue <= 64){
				fr1 = gMultTbl2[r][hue];	// r * hue / 64 ̂
				fr2 = gMultTbl2[r][hue2];
				fg1 = gMultTbl2[g][hue];
				fg2 = gMultTbl2[g][hue2];
				fb1 = gMultTbl2[b][hue];
				fb2 = gMultTbl2[b][hue2];
			}
			else if(hue > 64 && hue <= 128){
				fr1 = gMultTbl2[b][hue3];
				fr2 = gMultTbl2[b][hue4];
				fg1 = gMultTbl2[r][hue3];
				fg2 = gMultTbl2[r][hue4];
				fb1 = gMultTbl2[g][hue3];
				fb2 = gMultTbl2[g][hue4];
			}
			else if(hue > 128 && hue <= 192){
				fr1 = gMultTbl2[g][hue5];
				fr2 = gMultTbl2[g][hue6];
				fg1 = gMultTbl2[b][hue5];
				fg2 = gMultTbl2[b][hue6];
				fb1 = gMultTbl2[r][hue5];
				fb2 = gMultTbl2[r][hue6];
			}
			r = fr2 + fb1;
			g = fg2 + fr1;
			b = fb2 + fg1;
			if(r > 255)	r = 255;
			if(g > 255)	g = 255;
			if(b > 255)	b = 255;
			*pb = a | (r << 16) | (g << 8) | b;
			pb ++;
		}
		pb += width_rest;
	}
	
	return TRUE;
}// Hue

// ̕`iHBITMAPj
// str		: [IN]		
// size 	: [IN]		TCY
// x,y		: [IN]		\ʒu
// red		: [IN]		ԐF
// green	: [IN]		ΐF
// blue 	: [IN]		F
// ߂l	:			1:A0:s
BOOL CBm32::DrawFont(TCHAR *str, int size, int x, int y, BYTE red, BYTE green, BYTE blue)
{
	if(!m_hBmp) return FALSE;
	
	BOOL	res = FALSE;
	HDC 	hdcCp;
	HBITMAP hbmOld;
	HFONT	fontNew,fontOld;
	
	glFont.lfHeight = size;
	
	hdcCp = CreateCompatibleDC(NULL);
	if(hdcCp){
		hbmOld = (HBITMAP)SelectObject(hdcCp, m_hBmp);
		fontNew = CreateFontIndirect(&glFont);
		fontOld = (HFONT)SelectObject(hdcCp, fontNew);
		
		SetBkMode(hdcCp, TRANSPARENT);
		SetTextColor(hdcCp, RGB(red, green, blue));
		TextOut(hdcCp, x, y, str, lstrlen(str));
		
		SelectObject(hdcCp, hbmOld);
		SelectObject(hdcCp, fontOld);
		DeleteObject(fontNew);
		DeleteDC(hdcCp);
		res = TRUE;
	}
	
	return res;
}// DrawFont

// ̕`ifoCXReLXgj
// hDC		: [IN][OUT] foCXReLXg
// str		: [IN]		
// size 	: [IN]		TCY
// x,y		: [IN]		\ʒu
// red		: [IN]		ԐF
// green	: [IN]		ΐF
// blue 	: [IN]		F
// ߂l	:			1:A0:s
BOOL CBm32::DrawFontDC(HDC hDC, TCHAR *str, int size, int x, int y, BYTE red, BYTE green, BYTE blue)
{
	BOOL	res = FALSE;
	HFONT	fontNew,fontOld;
	
	if(hDC){
		glFont.lfHeight = size;
		
		fontNew = CreateFontIndirect(&glFont);
		fontOld = (HFONT)SelectObject(hDC, fontNew);
		
		SetBkMode(hDC, TRANSPARENT);
		SetTextColor(hDC, RGB(red, green, blue));
		TextOut(hDC, x, y, str, lstrlen(str));
		
		SelectObject(hDC, fontOld);
		DeleteObject(fontNew);
		res = TRUE;
	}
	
	return res;
}// DrawFontDC

// 32bppDIB ̐VK쐬
// width	: [IN]	摜̕
// height	: [IN]	摜̍
// ߂l	:		rbg}bvnh
HBITMAP CBm32::CreateSub(int width, int height)
{
	BITMAPINFO	bi;
	LPBYTE		buf;
	BITMAP		bmp;
	
	Delete();
	
	ZeroMemory(&bi, sizeof(bi));
	bi.bmiHeader.biSize 		= sizeof(BITMAPINFOHEADER);
	bi.bmiHeader.biWidth		= width;
	bi.bmiHeader.biHeight		= - height;
	bi.bmiHeader.biPlanes		= 1;
	bi.bmiHeader.biBitCount 	= 32;
	bi.bmiHeader.biCompression	= BI_RGB;
	
	HBITMAP hBmp = (HBITMAP) CreateDIBSection(NULL, &bi, DIB_RGB_COLORS, (VOID**) &buf, NULL, 0);
	
	GetObject(hBmp, sizeof(BITMAP), &bmp);
	
	m_nWidth	= bmp.bmWidth;
	m_nHeight	= bmp.bmHeight;
	m_nBPP		= bmp.bmBitsPixel;
	m_pBits		= (PBYTE) bmp.bmBits;
	
	return hBmp;
}// CreateSub

// `̗L͈͂擾
// xDst, yDst		: [IN]	Rs[W
// xSrc, ySrc		: [IN]	Rs[W
// width, height	: [IN]	Rs[`̕ƍ
// wdhDib, hgtDib	: [IN]	DIB̕ƍ
// ߂l			:		`̗L͈
RECT CBm32::Clip32(int x, int y, int width, int height, int wdhDib, int hgtDib)
{
	RECT	rc = {x, y, x + width, y + height};
	
	if(rc.left < 0) 		rc.left 	= 0;
	if(rc.top < 0)			rc.top		= 0;
	if(rc.right > wdhDib)	rc.right	= wdhDib;
	if(rc.bottom > hgtDib)	rc.bottom	= hgtDib;
	if(rc.right <= rc.left) rc.right	= 0;
	if(rc.bottom <= rc.top) rc.bottom	= 0;
	
	return rc;
}// Clip32

// CBm32 ̃fXgN^
CBm32::~CBm32()
{
	Delete();
}// ~CBm32

//--------------------------------------------------------------------------------------------

// CFont32 ̃RXgN^
CFont32::CFont32()
{
}// CFont32

// tHgݒ
// strFontName		: [IN]	tHg
// iWeight			: [IN]	iO`XOOj
// iCharSet 		: [IN]	Zbg
// iPitchAndFamily	: [IN]	Œ蕝tHgƃtHgt@~[
// iQuality 		: [IN]	i
void CFont32::Set(TCHAR *strFontName, int iWeight, int iCharSet, int iPitchAndFamily, int iQuality,
				BYTE bItalic, BYTE bUnderline, BYTE bStrikeOut)
{
	ZeroMemory(&glFont, sizeof(glFont));
	_tcsncpy(glFont.lfFaceName, strFontName, sizeof(glFont.lfFaceName));
	glFont.lfWeight 		= (int)  iWeight;
	glFont.lfCharSet		= (int)  iCharSet;
	glFont.lfPitchAndFamily = (int)  iPitchAndFamily;
	glFont.lfQuality		= (int)  iQuality;
	glFont.lfItalic			= (BYTE) bItalic;
	glFont.lfUnderline		= (BYTE) bUnderline;
	glFont.lfStrikeOut		= (BYTE) bStrikeOut;
}// Create

// CFont32 ̃fXgN^
CFont32::~CFont32()
{
}// ~CFont32
